@echo off
set GTK_CSD=0
cd /d "%~dp0"
title -= QEMU virtual machine =-

if exist zparams (
for /f "delims=" %%a in (zparams) do ^
if not defined _fw   (set "_fw=%%a")   else ^
if not defined _acc  (set "_acc=%%a") else ^
if not defined _vga  (set "_vga=%%a")  else ^
if not defined _type (set "_type=%%a") else ^
if not defined _ram  (set "_ram=%%a")  else ^
if not defined _cpu  (set "_cpu=%%a")  else ^
if not defined _misc (set "_misc=%%a") else ^
if not defined _fdb  (set "_fdb=%%a")  else ^
if not defined _hdb  (set "_hdb=%%a")  else ^
if not defined _hdd  (set "_hdd=%%a")  else ^
if not defined _last (set "_last=%%a") else ^
if not defined _lastF set "_lastF=%%a"
) else (
 set "_fw=BIOS"
 set "_acc=off"
 set "_vga=Cirrus"
 set "_type=i440FX + PIIX"
 set "_ram=1024"
 set "_cpu=default"
 set "_misc= "
 set "_fdb= "
 set "_hdb= "
 set "_hdd= "
)
if "%_acc:~0,1%"=="b" set "_acc=off"
if "%_misc:~0,1%"=="H" set "_misc= "
set _ro=Yes
for /f %%a in ('"prompt $H&for %%b in (1) do rem"') do set "BS=%%a"

if "%~1"=="" (
 set "_boot=None"
 set "_dev= "
) else (
 if /i "%~x1"==".iso" set _boot=G
 for %%i in (ima img) do if /i "%~x1"==".%%i" set _boot=C
 for %%i in (hdd vdi vhd vmdk) do if /i "%~x1"==".%%i" set _boot=F
 for %%i in (gz wim) do if /i "%~x1"==".%%i" set _boot=T& if "%_fw:~0,1%" neq "B" set "_fw=BIOS"
 if not defined _boot set _boot=V
 goto swap
)

:init
set isLast=& cls
echo/
call :getver
echo/
echo Boot from:
echo 
echo Device: %_boot%
echo Path:   %_dev%
if "%_fdb:~0,1%%_hdb:~0,1%%_hdd:~0,1%" neq "   " ^
echo 
if "%_fdb:~0,1%" neq " " echo FDB:    %_fdb%
if "%_hdb:~0,1%" neq " " echo HDB:    %_hdb%
if "%_hdd:~0,1%" neq " " echo HDD:    %_hdd%
echo 
echo Enter = Run QEMU    Ctrl+Q = Quit
echo Tab   = Switch dev  Ctrl+A = Accl
echo Space = Manage dev  BS = Last run
echo/
echo Options:
echo 
echo 1. Firmware: %_fw%
echo 
echo 2. Accel:    %_acc%
echo 3. Video:    %_vga%
echo 4. Chipset:  %_type%
echo 5. RAM:      %_ram% Mb
echo 6. CPU:      %_cpu%
echo 7. Misc:     %_misc%
echo 
echo 8. Readonly: %_ro%
echo 
<nul set /p "=> "
call :getkey
if "%key%"=="1" ^
if "%_fw%"=="BIOS" (set "_fw=BIOS [256k]") else ^
if "%_fw%"=="BIOS [256k]" (set "_fw=UEFI x64") else ^
if "%_fw%"=="UEFI x64" (set "_fw=UEFI x64 Secure Boot") else set "_fw=BIOS"

if "%key%"=="2" ^
if "%_acc%"=="off" (>nul sc query intelhaxm&& set "_acc=HAXM"|| (sc query hvhost| >nul find "RUNNING"&& set "_acc=Hyper-V")) else set "_acc=off"

if "%key%"=="3" ^
if "%_vga%"=="Cirrus"         (set "_vga=Standard") else ^
if "%_vga%"=="Standard"       (set "_vga=Standard,32Mb") else ^
if "%_vga%"=="Standard,32Mb"  (set "_vga=Standard,64Mb") else ^
if "%_vga%"=="Standard,64Mb"  (set "_vga=ISA-VGA") else set "_vga=Cirrus"

if "%key%"=="4" if "%_type%"=="i440FX + PIIX" (set "_type=Q35 + ICH9") else set "_type=i440FX + PIIX"
if "%key%"=="5" call :setram
if "%key%"=="6" call :setcpu

if "%key%"=="7" ^
if "%_misc%"==" " (set "_misc=-no-acpi") else ^
if "%_misc%"=="-no-acpi" (set "_misc=-no-hpet") else ^
if "%_misc%"=="-no-hpet" (set "_misc=-no-acpi -no-hpet") else ^
if "%_misc%"=="-no-acpi -no-hpet" (set "_misc=manual") else set "_misc= "

if "%key%"=="8" if "%_ro%"=="Yes" (set "_ro=No") else set "_ro=Yes"
if "%key%"=="	" if "%_boot:~0,1%" neq "N" goto swap
if "%key%"=="" echo Quit& goto :eof
if "%key%"=="" goto run
if "%key%"==" " goto mount

if "%key%"=="%BS%" if defined _last (
 echo %_last%| >nul find ",bootfile=grldr"&& (mklink /h g4d\image.ima %_lastF%& echo/)
 call set "param=%%_last%%"
 set isLast=1
 goto last
)
if "%key%"=="" if defined _lastF call %0 %_lastF%& exit
if "%key%"=="" goto accel
goto init

:getkey
set key=& for /f "usebackq delims=" %%a in (`2^>nul xcopy /l /w "%~f0" "%~f0"`) do set "key=%%a"& goto next
:next
set "key=%key:~-1%"
exit /b

:setram
echo/
set /p "_ram=Enter new RAM size (Mb): "
set /a _ram-=0
if %_ram% leq 0 set _ram=1024
exit /b

:setcpu
setlocal EnableDelayedExpansion
set cpu=%tmp%\cpu& >!cpu! rem/
set cnt=1& for /f "tokens=1*" %%a in ('qemu\qemu-system-x86_64.exe -cpu help') do ^
if "%%a"=="x86" (
 if !cnt! gtr 9 (>>%cpu% echo !cnt!. %%b) else >>%cpu% echo !cnt!.  %%b
 set /a cnt=!cnt!+1
)
>>%cpu% echo %cnt%. default
cls
type %cpu%|more
set skip=& set /p "skip=Enter CPU number: "
set /a skip-=1,cnt-=1
if %skip% lss 0 set skip=%cnt%
if %skip% gtr %cnt% set skip=%cnt%
if %skip%==0 (set skip=) else set skip=skip=%skip%
for /f "%skip% tokens=2 delims=. "  %%a in (%cpu%) do set cnt=%%a& goto next
:next
del /q %cpu%
endlocal& set _cpu=%cnt%
exit /b

:swap
if "%_boot:~0,1%"=="C" (
 set "_boot=Floppy drive image"
 set _dev="%~1"
) else ^
if "%_boot:~0,1%"=="F" (
 set "_boot=Virtual drive image"
 set _dev="%~1"
) else ^
if "%_boot:~0,1%"=="V" (
 set "_boot=Hard drive"
 call :chkdrv %~d1 _dev|| (
  set "_boot=CD/DVD drive"
  set "_dev=\\.\%~d1"
 )
) else ^
if "%_boot:~0,1%"=="H" (
 set "_boot=TFTP network loader"
 set "_dev=tftp=%~sdp1,bootfile=%~nx1"
) else ^
if "%_boot:~0,1%"=="T" (
 set "_boot=Grub4Dos PXE mode"
 set "_dev=tftp=%~sdp0g4d,bootfile=grldr"
) else (
 set "_boot=CD/DVD drive image"
 set _dev="%~1"
)
goto init

:run
set "param=-rtc base=localtime -m %_ram%"
if "%_acc%" neq "off" if "%_acc:~1,1%"=="A" (set "param=%param% -accel hax") else set "param=%param% -accel whpx"
if "%_cpu%" neq "default" set "param=%param% -cpu %_cpu%"
if "%_fw:~0,1%"=="U" (
 if "%_fw:~9,1%"=="" (set "param=%param% -bios efi64.bin") else set "param=%param% -pflash efi64.bin"
) else if "%_fw:~5,1%"=="" set "param=%param% -bios bios.bin"

if "%_vga%"=="Cirrus"  set "param=%param% -vga cirrus"
if "%_vga%"=="ISA-VGA" set "param=%param% -device isa-vga"
if "%_vga%"=="Standard,32Mb" set "param=%param% -device VGA,vgamem_mb=32"
if "%_vga%"=="Standard,64Mb" set "param=%param% -device VGA,vgamem_mb=64"

if "%_type:~0,1%"=="Q" set "param=%param% -M q35"
if "%_ro%"=="Yes" set "param=%param% -snapshot"
if "%_misc:~0,1%"=="-" set "param=%param% %_misc%"

if "%_boot:~0,1%"=="N" set "param=%param% -boot menu=on"
if "%_boot:~0,1%"=="C" set "param=%param% -cdrom %_dev% -boot order=d,menu=on"
if "%_boot:~0,1%"=="H" set "param=%param% -hda %_dev% -boot order=c,menu=on"
if "%_boot:~0,1%"=="F" set "param=%param% -fda %_dev% -boot order=a,menu=on"
if "%_boot:~0,1%"=="V" set "param=%param% -hda %_dev% -boot order=c,menu=on"
if "%_boot:~0,1%"=="T" set "param=%param% -net nic,model=e1000 -net user,tftp=%~sdp1,bootfile=%~nx1 -boot order=n,menu=on"
if "%_boot:~0,1%"=="G" set "param=%param% -net nic,model=e1000 -net user,tftp=%~sdp0g4d,bootfile=grldr -boot order=n,menu=on"&^
mklink /h g4d\image.ima %1& echo/
set "param=%param% %_fdb% %_hdb% %_hdd%"
if "%_ro%"=="No" set "param=%param:fat:/=fat:rw:/%"
:last
echo qemu %param%
echo/
if "%_misc%" neq "manual" goto next
set key=& set /p "key=Enter new options: "
set "param=%param% %key%"
echo/
echo ^> qemu %param%
echo/
:next
cd qemu
qemu-system-x86_64.exe %param%&& >..\zparams (
 echo %_fw%
 echo.%_acc%
 echo %_vga%
 echo %_type%
 echo %_ram%
 echo %_cpu%
 if "%_misc%"=="manual" (echo. ) else echo.%_misc%
 echo.%_fdb%
 echo.%_hdb%
 echo.%_hdd%
 if defined isLast (
  echo %_last%
  echo.%_lastF%
 ) else (
  echo %param%
  echo.%1
 )
)|| (echo/& pause)
cd ..
2>nul del /q g4d\image.ima
goto init

:: =================================================================================================

:mount
call :mnthdr
echo Space = Main menu
echo/
echo Action:
echo 
echo 1. Mount image file
echo 2. Mount disk/folder
echo 3. Create image file
echo 
echo 7. Unmount FDB
echo 8. Unmount HDB
echo 9. Unmount HDD
echo 
<nul set /p "=> "
set fname=& call :getkey
if "%key%"=="1" call :getfile&& goto attach
if "%key%"=="2" call :getfolder&& goto attach
if "%key%"=="3" goto creimg
if "%key%"=="7" set "_fdb= "
if "%key%"=="8" set "_hdb= "
if "%key%"=="9" set "_hdd= "
if "%key%"==" " goto init
if "%key%"=="" goto init
goto mount
:attach
set isD=& if "%fname:~-1%"=="\" (set isD=1) else if exist "%fname%\" set isD=1
:attach_cre
echo/
echo Mount to:
echo 
if not defined isD (
echo FDB:
echo 1. as floppy drive
echo 
)
echo HDB:
echo 2. as hard drive
if not defined isD ^
echo 3. as CD/DVD drive
echo 
echo HDD:
echo 4. as hard drive
if not defined isD ^
echo 5. as CD/DVD drive
echo 
<nul set /p "=> "
call :getkey
if defined isD goto next
if "%key%"=="1" set "_fdb=-fdb "%fname%""
if "%key%"=="3" set "_hdb=-drive file="%fname%",index=1,media=cdrom"
if "%key%"=="5" set "_hdd=-drive file="%fname%",index=3,media=cdrom"
:next
if "%key%"=="2" call :setdev hdb
if "%key%"=="4" call :setdev hdd
goto mount

:mnthdr
cls
echo/
call :getver
echo/
echo Mounted:
echo 
echo FDB: %_fdb%
echo HDB: %_hdb%
echo HDD: %_hdd%
echo 
exit /b

:setdev
if "%isD%" neq "1" set "_%1=-%1 "%fname%""& exit /b
if "%fname:~-2%" neq ":\" set "_%1=-%1 fat:/"%fname%""& exit /b
call :chkdrv %fname:~0,2% _ddd|| (set "_%1=-%1 fat:/"%fname%""& exit /b)
set _ddd=& set "_%1=-%1 %_ddd%"
exit /b

:creimg
call :getfolder|| goto mount
echo/
set f=image.vhd& set /p "f=Enter file name [image.vhd]: "
set "fname=%fname%\%f%"
set sz=& set /p "sz=Enter file size (Mb): "|| goto mount
echo/
echo   Drive layout:
echo   
echo * 1. Create empty drive
echo   2. Format to NTFS
echo   3. Format to FAT32
echo   
<nul set /p "=> "
set f=NONE& call :getkey
if "%key%"=="2" set f=NTFS
if "%key%"=="3" set f=FAT32
echo Format to: %f%
>%tmp%\f.txt (
 echo cre vdisk file="%fname%" maximum=%sz%
 if %f% neq NONE (
  echo attach vdisk
  echo convert mbr
  echo cre par prim
  echo for quick fs=%f%
  echo detach vdisk
 )
)
diskpart /s %tmp%\f.txt|| (echo/& pause& goto mount)
set isD=2
del /q %tmp%\f.txt
call :mnthdr
echo ^> %fname%
goto attach_cre

:: =================================================================================================

:accel
set _hax=& >nul sc query intelhaxm&& set "_hax=1"
set _w10=& for /f "tokens=4 delims=[]." %%i in ('ver') do if %%i geq 17134 set _w10=1
set _vm=& >nul sc query vmms&& set "_vm=1"
if defined _vm sc query hvhost| >nul find "RUNNING"&& set "_vm=on"|| set "_vm=off"

if defined _hax   (set _st=HAXM enabled) else (
 if "%_vm%"=="on"  set _st=Hyper-V enabled
 if "%_vm%"=="off" set _st=Hyper-V disabled
)
if not defined _hax ^
if not defined _vm set _st=No acceleration

cls
echo/
call :getver
echo/
echo Hardware acceleration
echo 
echo Status: %_st%
echo 
echo Space = Main menu
echo/
echo Action:
echo 

set _c+h=& set _c+v=& set _c+f=& set "_c+n="

if not defined _hax if not defined _vm (
echo Ctrl+H. Install HAXM& set _c+h=1
) else if "%_vm%"=="off" ^
echo Ctrl+H. Install HAXM& set _c+h=1

if not defined _vm if defined _w10 ^
echo Ctrl+V. Install Hyper-V  ( Restart required! )& set _c+v=1

if defined _vm if "%_vm%"=="on" (
echo Ctrl+F. Hyper-V turn OFF ( Restart required! ^)& set _c+f=1
 ) else ^
echo Ctrl+N. Hyper-V turn ON  ( Restart required! )& set _c+n=1

echo 
<nul set /p "=> "
call :getkey

if "%key%"=="" goto init
if "%key%"==" " goto init
if "%key%"=="" if defined _c+h for %%i in (haxm\*.exe) do %%i
if "%key%"=="" if defined _c+n call :ask "  Turn Hyper-V ON?  " 33&& (
 if defined _hax for %%i in (haxm\*.bat) do call %%i -u
 call :bcd_rst Auto
)
if "%key%"=="" if defined _c+f call :ask "  Turn Hyper-V OFF?  " 33&& call :bcd_rst off
if "%key%"=="" if defined _c+v call :ask "  Install Hyper-V support?  " 33&& (
 if defined _hax for %%i in (haxm\*.bat) do call %%i -u
 reg query "hklm\software\microsoft\windows nt\currentversion" /v productname| >nul find /i " home"&&^
for /f %%i in ('dir /b %SystemRoot%\servicing\Packages\*Hyper-V*.mum') do ^
Dism /Online /NoRestart /Add-Package:"%SystemRoot%\servicing\Packages\%%i"
 Dism /Online /Enable-Feature /FeatureName:Microsoft-Hyper-V /LimitAccess /All /NoRestart
 call :_rst
)
goto accel

:bcd_rst
bcdedit /set {current} hypervisorlaunchtype %1
:_rst
call :ask "  Restart PC now?  " 49&& shutdown -r -f -t 00
exit /b

:: =============================================================================================

:ask
>%tmp%\f.vbs echo WScript.Echo MsgBox(WScript.Arguments(0), %2, "  Question")
for /f "delims=" %%y in ('cscript //nologo %tmp%\f.vbs %1') do del /q %tmp%\f.vbs& if %%y==1 exit /b
exit /b 1

:getfile
>%tmp%\f.vbs echo WScript.Echo CreateObject("WScript.Shell").Exec("mshta.exe ""about:<input type=file id=FILE><script>FILE.click();new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).WriteLine(FILE.value);close();resizeTo(0,0);</script>""").StdOut.ReadLine
goto next
:getfolder
>%tmp%\f.vbs (
 echo set oFolder=WScript.CreateObject("Shell.Application"^).BrowseForFolder(0, " /  ", 8, 17^)
 echo If not oFolder is Nothing Then WScript.Echo oFolder.Self.Path
)
:next
for /f "delims=" %%a in ('cscript //nologo %tmp%\f.vbs') do echo %%a& set "fname=%%a"
del /q %tmp%\f.vbs
if defined fname exit /b
exit /b 1

:chkdrv
for /f "tokens=3" %%a in ('(echo sel vol %1^& echo det vol^)^| diskpart^| find "*"') do set "%2=\\.\PhysicalDrive%%a"& exit /b
exit /b 1

:getver
for /f "tokens=1 delims=()" %%a in ('qemu\qemu-system-x86_64.exe -version') do echo ^> %%a& exit /b

